angular
  .module \app
  .controller do
     * \allactivities
     AllActivitiesController

!function AllActivitiesController $scope, $root-scope, $state, $filter, $xabl, $location, ENV, ablConstants, debug
    vm = this
    vm.loading = true
    vm.page = \allactivities
    vm.page-size = 5
    vm.current-page = 0
    vm.max-pages = 0
    vm.loading-more-activities = false
    vm.activities = []
    vm.load-operator = load-operator
    vm.go-to-activity-by-id = go-to-activity-by-id
    vm.see-more = see-more
    load-operator!
    
    $scope.$on \scroll-bottom, !->
      if !vm.loading-more-activities then if vm.current-page < vm.max-pages then load-activities!
      
    !function load-operator
      #call to api
      $xabl.get("operators/" + $state.params.merchant).then ((response1)!->
        data1 = response1.data
        vm.theme = if typeof data1.preferences.widget.display.theme is 'undefined' then default-theme else data1.preferences.widget.display.theme 
        ablConstants.setCompanyName data1.companyName
        vm.operator = data1
        vm.merchant = $state.params.merchant
        #debug \operatorCurrency, data1
        if data1.currency
            $root-scope.currency = data1.currency
        else
          $root-scope.currency = "usd"
        load-activities! ), (error)!->
        vm.status = \error
        vm.message = ablConstants.getPageErrorMessages!
        vm.loading = false

    !function load-activities
      vm.loading-more-activities = true
      params = {}
      date = moment!.format!
      length = 250
      debug(\$xabl, $xabl)
      $xabl.options.key = $state.params.merchant;
      $xabl.get("activities?pageSize="+vm.page-size+"&page="+vm.current-page+"&dateRange[]="+date+"&noEmpty=true").then ((response2)!->
        data2 = response2.data
        vm.current-page = get-page-number(response2.headers \x-next-page-url) - 1
        vm.max-pages = get-page-number response2.headers \x-last-page-url
        angular.forEach data2.list, (v, k) ->
          description-length = v.description.length
          v.see-description = 'See more'
          if description-length >= length
            v.description-short = v.description.substring(0, length) + \...
            v.description-long = v.description
            v.description = v.description-short
            v.which-description = \short
            v.two-description = true
          else
            v.description-short = v.description
            v.description-long = v.description
            v.which-description = \long
            v.description = v.description-long
          vm.activities.push v
        vm.loading = false 
        vm.loading-more-activities = false
        vm.current-page++), (error)!->
        vm.status = \error
        vm.message = ablConstants.getPageErrorMessages!
        vm.loading = false
        vm.loading-more-activities = false
              
    !function go-to-activity-by-id (activity)
      $location.path '/merchant/'+$state.params.merchant+'/activity/'+activity
      
    function get-page-number _url
      url = _url.split \?
      params = url[1].split \&
      value-key = params[1].split \=
      value-key[1]      
      
    !function see-more activity
      if activity.which-description is \short
        activity.see-description = 'See less'
        activity.which-description = \long
        activity.description = activity.description-long
      else
        activity.see-description = 'See more'
        activity.which-description = \short
        activity.description = activity.description-short
        
      
      
        
                    