angular
  .module \app
  .directive do
    * \openWidget
    OpenWidgetDirective
             
function OpenWidgetDirective $state, $window, ENV, debug
  const widget-url = ENV.widgetUrl
  const mobile-url = ENV.mWidgetUrl
  directive =
    restrict: \A
    replace: false
    scope:
      * activity:'='
        eventId:'@'
    link: (scope, element, attrs)!->
      element.on 'click', ->
        return if attrs.enabled != 'true'
        config = 
          merchant: $state.params.merchant
          activity: scope.activity
          event: scope.eventId
          day: attrs.day
        delete config.activity if !config.activity? or config.activity is \undefined
        delete config.event if !config.event? or config.event is \undefined or config.event == ""
        delete config.day if !config.day? or config.day is \undefined
        recursiveDecoded = decodeURIComponent( jQuery.param( config ) )
        if /android|webos|iphone|ipad|ipod|blackberry|iemobile|opera mini/i.test(navigator.user-agent.to-lower-case!)
          h = $window.outerHeight
          w = $window.outerWidth
          return  $window
           .open do
             * "#{mobile-url}?#recursiveDecoded"
             * "Widget"
             * "height=#h, width=#w, top=0, left=0, scrollbars=0"
           .focus!
        iframe =
          jQuery("<iframe frameborder='0' 
                     width='1000'
                     height='500' 
                     src='#{widget-url}iframe.html?#recursiveDecoded'></iframe>")
        $window.addEventListener do 
            * \message
            * (event)->
                switch event.data 
                  case \abl_closable
                     event.source.postMessage("abl_closable", event.origin)
                  case \abl_closed 
                     iframe.remove!
                     backdrop.remove!
            * no
 
        backdrop = 
          jQuery('<div></div>')
              .css(\position, \fixed)
              .css(\top, 0)       
              .css(\left, 0)
              .css(\width, \100%)
              .css(\height, \100vh)
              .css(\background-color, "rgba(0,0,0,0.3)")
              .css(\z-index, 999999)
              .css(\text-align, \center)
              .append-to jQuery(\body)
        iframe
              .css(\display, \inline-block)
              .css(\overview, \hidden)
              .css("box-shadow", "0px 0px 10px black")
              .css(\margin-top, \20px)
              .append-to backdrop