angular
  .module \app
  .directive do 
     * \ablHeader
     HeaderDirective
  .directive do 
     * \ablFooter
     FooterDirective
  .directive do
     * \ablLinkToAbl
     LinkToAblDirective
  .directive do
     * \ablOpenNewWindow
     OpenNewWindowDirective
     
function HeaderDirective $state, ablConstants, debug
  directive =
    restrict: \E
    scope: 
      * vm:'='
    template-url: \header
    link: link
  !function link scope, element, attrs 
    scope.all-activities-page = ablConstants.getAllActivitiesPage!
    scope.$watch (-> scope.vm.operator), ((newValue, oldValue)!-> 
      if newValue
        scope.operator = newValue )
    scope.$watch (-> scope.vm.activity), ((newValue, oldValue)!-> 
      if newValue
        scope.activity = newValue )
    scope.selectDay = selectDay
    !function selectDay (day)
      disabled = scope.model().isDisabledDay(day)
      if !disabled
        scope.model().selectDay day
    Localize.getAvailableLanguages ( (err, languages) !->
      scope.languages = languages
      angular.for-each languages, (k, v) !->
        if k.code is Localize.getLanguage()
          scope.current-language = k.name
          scope.current-language-class = k.code )
    
    scope.set-current-language = (lang)!->
      Localize.setLanguage lang.code
      scope.current-language = lang.name
      scope.current-language-class = lang.code
  directive
  
function FooterDirective $state, debug
  directive =
    restrict: \E
    scope: 
      * vm:'='
    template-url: \footer
    link:link
  !function link scope, element, attrs 
    scope.$watch (-> scope.vm.operator), ((newValue, oldValue)!-> 
      if newValue
        scope.operator = newValue )
    scope.$watch (-> scope.vm.activity), ((newValue, oldValue)!-> 
      if newValue
        scope.activity = newValue )
    scope.selectDay = selectDay
    !function selectDay (day)
      disabled = scope.model().isDisabledDay(day)
      if !disabled
        scope.model().selectDay day
  directive

function LinkToAblDirective $state, debug
  directive =
    restrict: \A
    link:link
  !function link scope, element, attrs 
    element.bind \click, !->
      #TODO: Adventure Bucket List website
      window.open 'http://www.adventurebucketlist.com'
  directive
  
function OpenNewWindowDirective $state, debug
  directive =
    restrict: \A
    link:link
  !function link scope, element, attrs 
    element.bind \click, (e) !->
      e.preventDefault()
      window.open attrs.href
  directive